## Game loop

# Player handling (pcompat)
execute as @a[tag=!registered] run function chop:pcompat/new_game
execute as @a[scores={leave=1..}] run function chop:pcompat/old_game

# Teleports players back into position if they move
execute unless entity @s[tag=4player] as @e[scores={playerID=1}] at @s if block ~ ~ ~ structure_void run tp @s -25 60 90 -90 45
execute unless entity @s[tag=4player] as @e[scores={playerID=2}] at @s if block ~ ~ ~ structure_void run tp @s 25 60 90 90 45
execute if entity @s[tag=4player] as @e[scores={playerID=1}] at @s if block ~ ~ ~ structure_void run tp @s 0 61 -60 180 45
execute if entity @s[tag=4player] as @e[scores={playerID=2}] at @s if block ~ ~ ~ structure_void run tp @s 0 61 -121 0 45
execute if entity @s[tag=4player] as @e[scores={playerID=3}] at @s if block ~ ~ ~ structure_void run tp @s -30 61 -90 -90 45
execute if entity @s[tag=4player] as @e[scores={playerID=4}] at @s if block ~ ~ ~ structure_void run tp @s 31 61 -90 90 45

# Detects players rotating their circle
execute unless entity @s[tag=4player] as @e[scores={playerID=1}] run function chop:game/turn1
execute unless entity @s[tag=4player] as @e[scores={playerID=2}] run function chop:game/turn2
execute if entity @s[tag=4player] as @e[scores={playerID=1}] run function chop:game/4turn1
execute if entity @s[tag=4player] as @e[scores={playerID=2}] run function chop:game/4turn2
execute if entity @s[tag=4player] as @e[scores={playerID=3}] run function chop:game/4turn3
execute if entity @s[tag=4player] as @e[scores={playerID=4}] run function chop:game/4turn4

# Rage powerup spawntime increase (doubled) | Spawnside is set in chop:game/spawn2
execute if entity @s[tag=rage1] run scoreboard players add @s spawntimer 1
execute if entity @s[tag=rage2] run scoreboard players add @s spawntimer 1
execute if entity @s[tag=rage1] run scoreboard players add @s rageTimer 1
execute if entity @s[tag=rage2] run scoreboard players add @s rageTimer 1
tag @s[scores={rageTimer=150..}] remove rage1
tag @s[scores={rageTimer=150..}] remove rage2
scoreboard players reset @s[scores={rageTimer=150..}] rageTimer

# Spawns block after 30 ticks
scoreboard players add @s spawntimer 1
scoreboard players add @s[tag=4player] spawntimer 1
execute unless entity @s[tag=4player] if entity @s[scores={spawntimer=30..}] as @e[name=spawn,sort=random,limit=1,tag=color] at @s run function chop:game/spawn
execute if entity @s[tag=4player] if entity @s[scores={spawntimer=30..}] as @e[name=spawn2,sort=random,limit=1,tag=color] at @s run function chop:game/spawn

# Runs all commands executing on blocks/powerups
execute unless entity @s[scores={spawntimer=..-10}] as @e[name=color] at @s run function chop:game/color
execute unless entity @s[scores={spawntimer=..-10}] as @e[name=powerup] at @s run function chop:game/powerup

# Displays health
execute as @a[scores={health=0..}] run title @s actionbar ["",{"text":"Your Health: ","color":"dark_aqua"},{"score":{"name":"@s","objective":"health"},"bold":true,"color":"red"},{"text":"\u2665","bold":true,"color":"dark_red"}]

# Advances difficulty after a set period of time
function chop:game/difficulty


# Every 100 ticks, 1/9 chance of spawning powerup
scoreboard players add @s[scores={powerupToggle=1}] powerup 1
execute unless entity @s[tag=4player] if entity @s[scores={powerup=100..}] unless entity @e[name=powerup] as @e[name=spawn,sort=random,limit=1] if entity @s[tag=5] at @s run function chop:game/spawn_powerup
execute if entity @s[tag=4player] if entity @s[scores={powerup=100..}] unless entity @e[name=powerup] as @e[name=spawn2,sort=random,limit=1] if entity @s[tag=5] at @s run function chop:game/spawn_powerup
scoreboard players set @s[scores={powerup=100..}] powerup 0

# Use powerup
execute as @a[nbt={SelectedItem:{id:"minecraft:light_blue_dye"}}] run function chop:game/powerups/reverse
execute as @a[nbt={SelectedItem:{id:"minecraft:light_gray_dye"}}] run function chop:game/powerups/lightning
execute as @a[nbt={SelectedItem:{id:"minecraft:rose_red"}}] run function chop:game/powerups/wipeout
execute as @a[nbt={SelectedItem:{id:"minecraft:purple_dye"}}] run function chop:game/powerups/rage

# As AI entity
execute as @e[type=armor_stand,name=AI] at @s run function chop:game/ai

execute unless entity @e[name=powerup] run kill @e[name="Powerup"]
scoreboard players set powerups powerups_on_map 0
execute as @e[name=powerup] run scoreboard players add powerups powerups_on_map 1
execute if score powerups powerups_on_map matches 2.. as @e[name=powerup,limit=1,sort=random] at @s run function chop:game/kill_excess_powerups

execute as @e[type=item,nbt={Item:{id:"minecraft:red_stained_glass_pane",Count:1b}}] run data merge entity @s {PickupDelay:0}
execute as @e[type=item,nbt={Item:{id:"minecraft:light_blue_stained_glass_pane",Count:1b}}] run data merge entity @s {PickupDelay:0}
execute as @e[type=item,nbt={Item:{id:"minecraft:yellow_stained_glass_pane",Count:1b}}] run data merge entity @s {PickupDelay:0}
execute as @e[type=item,nbt={Item:{id:"minecraft:lime_stained_glass_pane",Count:1b}}] run data merge entity @s {PickupDelay:0}